*
      SUBROUTINE CAL_POSVN(NAME, UPLO, N, NPROW, NPCOL, AMEM, MEMSIZE,
     $                     NB, INFILEA, INFILEB, OUTFILE,  TFILE,
     $                     NPRT, CTXT)
*
*      (PDPOSV, PDPOSV1, PDPOSV2)
*       
*    ( )
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE, NPRT, CTXT
      DOUBLE PRECISION   AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, INFILEB, OUTFILE, TFILE, NAME, UPLO
*
*   -  
      INTEGER            NOUT, NOUT1, NIN, NPR
      PARAMETER          ( NOUT1 = 12, NOUT = 13, NIN = 11, NPR = 6 )
*
*   
      INTEGER            I, IAM, INFO, IPA, IPB, IPX, IPW,
     $                   IPAF, IPFER, IPBER, IPWOR, IPIWOR,
     $                   IPLWORK, IPLIWORK, J, MYCOL, MYROW, NP, NQ,
     $                   NBRHS, NRHS, NQRHS, LWORK, LIWORK,
     $                   IA, JA, IB, JB, IAF, JAF, IX, JX,
     $                   NPROCS, MMIN, WORKSIZ
*
      DOUBLE PRECISION   RCOND
*
*  
      INTEGER            DESCA( 9), DESCB( 9), DESCX( 9), DESCAF( 9),
     $                   ILIWORK(1)
*
      DOUBLE PRECISION   ALWORK(1), time, time1, time2
*
      COMMON             time, J
*
*  
      INTEGER            ICEIL, NUMROC, ILCM
      DOUBLE PRECISION   PDLAMCH, PDLANGE
      EXTERNAL           ICEIL, ILCM, NUMROC, PDLAMCH, PDLANGE
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PDLAPRNT, PDLAREAD,
     $                   PDLAWRITE, MINTPOSV,
     $                   PDPOSV, PDPOSV1, PDPOSV2
*
*  
*
*  
*
**      NPROCS = NPROW*NPCOL
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      IAF = 1
      JAF = 1
      IX = 1
      JX = 1
      NRHS = 1
      NBRHS = 1
*
*    BLACS'    
*
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
**        WRITE( NPR, FMT = * )'CAL_POSVN 1'
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
**        WRITE( NPR, FMT = * )'CAL_POSVN 2'
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
       NQRHS = NUMROC( NRHS, NB, MYCOL, 0, NPCOL )
*
*     A,   X
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
      CALL DESCINIT(DESCB, N, NRHS, NB,NBRHS, 0,0, CTXT,MAX(1,NP),INFO)
      CALL DESCINIT(DESCX, N, NRHS, NB,NBRHS, 0,0, CTXT,MAX(1,NP),INFO)
      CALL DESCINIT(DESCAF, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*
*    ()   B
*
      IPB = IPA + DESCA( 9 )*NQ
*
*      PDPOSV
*
      IPW = IPB + DESCB( 9 )*NQRHS
*
      IF( NAME .NE. 'PDPOSV2' ) GOTO 1
*
*     AF,  X, FER, BER
*
      IPAF = IPB + DESCB( 9 )*NQRHS
      IPX = IPAF + DESCAF( 9 )*NQ
*
      IPFER = IPX + DESCX( 9 )*NQRHS
      IPBER = IPFER + DESCX(9)*NQRHS
      IPWOR = IPBER + DESCX(9)*NQRHS
*
*   ,    PDPOSV2
*
*      LWORK = 4*NP
      LWORK = 3*NP
      LIWORK = NP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GO TO 3
*
    1 IF( NAME .NE. 'PDPOSV1' ) GOTO 7
*
      IPWOR = IPB + DESCB( 9 )*NQRHS
*
*   ,    PDPOSV1
*
      LWORK = 3*NP + 2*NQ + MAX( 2, MAX(NB*ICEIL(NPROW-1,NPCOL),
     $        NQ) ) + NB*ICEIL(NPCOL-1,NPROW)
**      LWORK = 3*DESCA(9)
      LIWORK = NP
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GO TO 3
    7 IPWOR = 0
      IF( NAME .NE. 'PDPOSV' ) GOTO 10
      GO TO 3 
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP )
*
      INFO = 0
*        
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
**        WRITE( NPR, FMT = * )'CAL_POSVN 3'
*
 9991 FORMAT( /'LWORK =', I5,',  LIWORK =',I5//)
 9994 FORMAT( / 5I7 /)
 9983 FORMAT( / 'UPLO = ', A /)
 9985 FORMAT( / 9I5 /)
*
**        WRITE( NPR, FMT = * )'CAL_POSVN 4'
*
*   ( )     A  B
*
      IF( INFILEA .EQ. ' ' ) THEN
         CALL MINTPOSV( N, AMEM(IPA), DESCA, AMEM(IPB), DESCB, INFO )
      ELSE
         CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
         CALL PDLAREAD(INFILEB, AMEM(IPB), DESCB, 0, 0, AMEM(IPW))
      END IF
*
**        WRITE( NPR, FMT = * )'CAL_POSVN 5'
*
*    
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 .OR. NPRT .EQ. 2 ) GO TO 8
      IF( J .NE. 1 ) GO TO 8
*
*   
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'   IPA,   IPB,  IPWOR,  IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPB, IPWOR, IPW, MMIN
*
         IF( NAME .NE. 'PDPOSV2' ) GOTO 5
         WRITE( NPR, FMT = * )'   IPAF,   IPX, IPFER,   IPBER, IPWOR'
         WRITE( NPR, FMT = 9994 )IPAF, IPX, IPFER, IPBER, IPWOR
    5    WRITE( NPR, FMT = 9983 ) UPLO
         IF( NAME .EQ. 'PDPOSV' ) GOTO 4
         WRITE( NPR, FMT = 9991 )LWORK, LIWORK
    4    WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  DESCB'
         WRITE( NPR, FMT = 9985 )DESCB
         WRITE( NPR, FMT = * ) '  DESCX'
         WRITE( NPR, FMT = 9985 )DESCX
         IF( NAME .NE. 'PDPOSV2' ) GOTO 2
         WRITE( NPR, FMT = * ) '  DESCAF'
         WRITE( NPR, FMT = 9985 )DESCAF
    2    WRITE( NPR, FMT = * ) '  A'
      END IF
*
      CALL PDLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  B'
      END IF
*
      CALL PDLAPRNT( N, NRHS, AMEM(IPB), IB, JB, DESCB, 0, 0, 'B',
     $               NPR, AMEM( IPW ) )
*
*    A * X = B
*
    8 IF( NAME .EQ. 'PDPOSV1' ) GOTO 11
      IF( NAME .EQ. 'PDPOSV2' ) GOTO 12
      IF( NAME .NE. 'PDPOSV' ) GOTO 10
*
      time1 = MPI_Wtime()
*
      CALL PDPOSV( UPLO, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $             AMEM(IPB), IB, JB, DESCB, INFO )
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
 9999 FORMAT( /' (Wtime) =', D14.3, ' time1 =', D12.3,
     $        ' time2 =', D14.3 )
*
      GOTO 99
*
   11 CONTINUE
      time1 = MPI_Wtime()
*
      CALL PDPOSV1( UPLO, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPB), IB, JB, DESCB,
     $              RCOND, AMEM(IPWOR), LWORK, AMEM(IPIWOR),
     $              LIWORK, INFO)
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*
   12 CONTINUE
      time1 = MPI_Wtime()
*
      CALL PDPOSV2( UPLO, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPAF),IAF, JAF, DESCAF,
     $              AMEM(IPB), IB, JB, DESCB, AMEM(IPX), IX, JX, DESCX,
     $              AMEM(IPFER), AMEM(IPBER),
     $              AMEM(IPWOR), LWORK, AMEM(IPIWOR), LIWORK, INFO)
*
      time2 = MPI_Wtime()
      time = time2 - time1
*
      GOTO 99
*
*   X
*
   99 CONTINUE
*
*      
*
      IF( J .NE. 1 .AND. J .NE. 2000 ) GO TO 17
      IF( NPRT .EQ. 0 .OR. NPRT .EQ. 1 ) GO TO 27
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         IF( NAME .NE. 'PDPOSV1' ) GOTO 14
         WRITE( NPR, FMT = 9996 )INFO, RCOND
         GOTO 9
   14    WRITE( NPR, FMT = 9995 )INFO
    9    WRITE( NPR, FMT = * ) '   X'
      END IF
*
      IF( NAME .NE. 'PDPOSV2' ) GOTO 15
*
      IF( N .LE. 1000 ) GO TO 23
*
      CALL PDLAPRNT( 3, NRHS, AMEM(IPX), IX, JX, DESCX, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
      GO TO 27
*
   23 CALL PDLAPRNT( N, NRHS, AMEM(IPX), IX, JX, DESCX, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
      GO TO 27
*
   15 IF( N .LE. 1000 ) GO TO 25
*
      CALL PDLAPRNT( 3, NRHS, AMEM(IPB), IB, JB, DESCB, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
      GO TO 27
*
   25 CALL PDLAPRNT( N, NRHS, AMEM(IPB), IB, JB, DESCB, 0,0, 'X', NPR,
     $               AMEM( IPW ) )
*
   27 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
        WRITE( NPR, FMT = * )' : ', MMIN, MEMSIZE, J
      END IF
*
   17 CONTINUE
*
*        
*  ,      ' '.
*
      IF( OUTFILE .EQ. ' ' ) GO TO 21
*
      IF( NAME .NE. 'PDPOSV2' ) GOTO 16
*
      CALL PDLAWRITE( OUTFILE, N, NRHS, AMEM(IPX), 1, 1, DESCX,
     $                0, 0, AMEM(IPW) )
      GO TO 10
*
   16 CALL PDLAWRITE( OUTFILE, N, NRHS, AMEM(IPB), 1, 1, DESCB,
     $                0, 0, AMEM(IPW) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
   21 CONTINUE
*
**        WRITE( NPR, FMT = * )'CAL_POSVN 8'
*
*         WRITE( NPR, FMT = * ) '  '
*
*       
*   ,  
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
*
**         OPEN( NOUT1, FILE = TFILE, STATUS = 'OLD' )
*
        IF( J .NE. 1 ) GO TO 28
*
          WRITE( NOUT1, FMT = * )' : ', MMIN, MEMSIZE, J
*
   28     WRITE( NOUT1, FMT = 2001 ) NPROW, NPCOL, NB, time
*
**         WRITE( NOUT1, FMT = 9999 )time, time1, time2
      END IF
*
**        WRITE( NPR, FMT = * )'CAL_POSVN 9'
*
   10 CONTINUE
*
**      CALL BLACS_BARRIER( CTXT, 'A' )
*
   20 CONTINUE
*
**      IF( IAM .EQ. 0 ) THEN
**         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 )
**      CLOSE( NOUT )
**      END IF
*
**      CALL BLACS_EXIT( 0 )
*
 2001 FORMAT( 3I5, D14.3/ )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'  A X = B ,'//' A - ',I5,' ',I5,',',
     $       /'        ', I3, '  ', I3, /)
*
 9997 FORMAT( / '   ', I3, ' ,',
     $       '    ', I3, '  ', I3 /)
 9995 FORMAT( / '  INFO =', I6, '   RCOND  = ', E16.8 /)
 9996 FORMAT( / '  INFO  = ', I6 /)
      RETURN
      END
 
